package mixer;

import java.util.ArrayList;
import java.util.List;
import java.util.Random;

/**
 * Created by Tzlil on 12/17/2015.
 */
class RandomPermutation {

    protected  final int[] permutation;

    protected  RandomPermutation(int n,Random random)
    {
        List<Integer> numbers= new ArrayList<Integer>(n);
        for (int i = 0; i < n; i++)
        {
            numbers.add(i);
        }

        int[] result = new int[n];
        int index;
        for (int i = 0; i < n; i++)
        {
            index = random.nextInt(n - i);
            result[i] = numbers.get(index);
            numbers.remove(index);
        }
        permutation = result;
    }
}
